unit Unit80;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, TeeChartGrid, ExtCtrls, TeeProcs, TeEngine, Chart, Series,
  StdCtrls;

type
  TChartData = array[0..2, 0..9] of double;
  TForm80 = class(TForm)
    Chart1: TChart;
    ChartGrid1: TChartGrid;
    Series1: TAreaSeries;
    Panel1: TPanel;
    ListBox1: TListBox;
    Panel2: TPanel;
    Panel3: TPanel;
    rbtnData1: TRadioButton;
    rbtnData3: TRadioButton;
    rbtnData2: TRadioButton;
    procedure ListBox1Click(Sender: TObject);
    procedure rbtnData1Click(Sender: TObject);
  private
    function GetChartData: TChartData;
    procedure UpdateChartGrid;
    { Private declarations }
  public
    { Public declarations }
    constructor Create(aOwner: TComponent); override;
    procedure UpdateChart;
  end;

var
  Form80: TForm80;

implementation

{$R *.dfm}

uses Math;

{ TForm80 }

const
  CHART_DATA1: TChartData =
    ((  9, 9, 1, 0, 0, 0, 0, 0, 1, 10),
     (  1, 1, 9, 10, 10, 10, 10, 10, 9, 0),
     (  0, 0, 0, 0, 0, 0, 0, 0, 0, 0));{}

  CHART_DATA2: TChartData =
    (( 11, 2, 2, 2, 1, 0, 0, 2, 2, 2),
     (  0, 9, 9, 9, 9, 9, 9, 9, 9, 9),
     (  0, 0, 0, 0, 1, 0, 0, 1, 0, 0));{}

  CHART_DATA3: TChartData =
    ((100, 103, 20, 10, 0, 0, 0, 0, 0, 0),
      (0, 0, 86, 20, 20, 30, 0, 0, 0, 0),
      (0, 0, 0, 79, 93, 86, 119, 123, 127, 130));


function TForm80.GetChartData: TChartData;
begin
  if rbtnData2.Checked then
    result := CHART_DATA2
  else
  if rbtnData3.Checked then
    result := CHART_DATA3
  else
    result := CHART_DATA1
end;

constructor TForm80.Create(aOwner: TComponent);
begin
  inherited;
  UpdateChart;
end;

procedure TForm80.ListBox1Click(Sender: TObject);
begin
  UpdateChartGrid;
end;

procedure TForm80.rbtnData1Click(Sender: TObject);
begin
  UPdateChart;
end;

procedure TForm80.UpdateChartGrid;
begin
  if LIstBox1.ItemIndex > -1 then
    ChartGrid1.Series := TChartSeries(ListBox1.Items.Objects[LIstBox1.ItemIndex]);
end;

procedure TForm80.UpdateChart;

  function CreateChartSeries(const aIdx: integer): TAreaSeries;
  begin
    result := TAreaSeries.Create(self);
    result.ParentChart := Chart1;
    result.AreaLinesPen.Visible := false;
    result.Pen.Visible := false;
    result.Title := 'Series #' + IntToSTr(aIdx);
    result.MultiArea := maStacked;
  end;

var
  I: integer;
  J: integer;
  lLastValue: Extended;
  lSrs: TChartSeries;
  lLastIdx: Integer;
  lIncome: Double;
  lPt: TPoint;
  lStairs: array of TPoint;
  lChartData: TChartData;
begin
  lChartData := GetChartData;
  Chart1.FreeAllSeries;
  for I := Low(lChartData) to High(lChartData) do
  begin
    lsrs := CreateChartSeries(I);

    lLastValue := 0.0;

    lLastIdx := High(lChartData[I]);
    for J := 0 to lLastIdx do
    begin
      lIncome := lChartData[I, J];

      //see if previous month income was zero, if so, add 0 here

      if (lIncome > 0) then
      begin
        if (J > 0) and (lLastValue = 0) then
        begin
          //no value for previous item, step into current value
          lsrs.AddXY(J, 0, IntToStr(J));

          SetLength(lStairs, Length(lStairs) + 1);
          lStairs[Length(lStairs)-1] := Point(I, J);
        end;{}

        lsrs.AddXY(J, lIncome, IntToStr(J));

        if (J < lLastIdx) and (lChartData[I, J+1] = 0) then
        begin
          //no value for next item, step chart down to zero
          lsrs.AddXY(J, 0, IntToStr(J));

          SetLength(lStairs, Length(lStairs)+1);
          lStairs[Length(lStairs)-1] := Point(I, Max(J+1, 0));
        end;{}
      end
      else
        lsrs.AddNullXY(J, 0, IntToStr(J));

      lLastValue := lIncome;
    end;
  end;

  for I := Length(lStairs) - 1 downto 0 do
  begin
    lPt := lStairs[I];
    for J := 0 to Chart1.SeriesCount -1 do
      if J <> lPt.X then
      begin
        lsrs := Chart1[J];
        lsrs.AddXY(lSrs.XValue[lPt.Y], lSrs.YValue[lPt.Y]);
      end;
  end;

  Caption := '';
  for I := 0 to Chart1.SeriesCount -1 do
    Caption := Caption + '; ' + Chart1[I].Title  + ': ' + IntToStr(Chart1[I].Count);
  Caption := Copy(Caption, 3, MaxInt);



  LIstBox1.Items.Clear;
  for I := 0 to Chart1.SeriesCount -1 do
    LIstBox1.Items.AddObject(Chart1[I].Title, Chart1[I]);
  ListBox1.ItemIndex := 0;
  UpdateChartGrid;


end;

end.
